Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4268)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4270)
@@ -8697,6 +8877,5 @@
 !--             For each hour of year:
                 IF ( check_existence( aero_emission_att%var_names, 'nhoursyear' ) )  THEN
-                   CALL get_dimension_length( id_salsa,                                            &
-                                              aero_emission_att%nhoursyear, 'nhoursyear' )
+                   CALL get_dimension_length( id_salsa, aero_emission_att%nhoursyear, 'nhoursyear' )
                    ALLOCATE( aero_emission_att%etf(1:aero_emission_att%ncat,                       &
                                                    1:aero_emission_att%nhoursyear) )
@@ -8706,6 +8885,5 @@
 !--             Based on the month, day and hour:
                 ELSEIF ( check_existence( aero_emission_att%var_names, 'nmonthdayhour' ) )  THEN
-                   CALL get_dimension_length( id_salsa,                                            &
-                                              aero_emission_att%nmonthdayhour,                     &
+                   CALL get_dimension_length( id_salsa, aero_emission_att%nmonthdayhour,           &
                                               'nmonthdayhour' )
                    ALLOCATE( aero_emission_att%etf(1:aero_emission_att%ncat,                       &
@@ -8720,42 +8898,6 @@
 !
 !--             Next emission update
-                CALL get_date_time( 0.0_wp, second_of_day=second_of_day )
-                next_aero_emission_update = MOD( second_of_day, seconds_per_hour ) - seconds_per_hour
-!
-!--             Get chemical composition (i.e. mass fraction of different species) in aerosols
-                IF ( check_existence( aero_emission_att%var_names, 'emission_mass_fracs' ) )  THEN
-                   ALLOCATE( aero_emission%def_mass_fracs(1:aero_emission_att%ncat,                &
-                                                          1:aero_emission_att%ncc) )
-                   aero_emission%def_mass_fracs = 0.0_wp
-                   CALL get_variable( id_salsa, 'emission_mass_fracs', aero_emission%def_mass_fracs,&
-                                      0, aero_emission_att%ncc-1, 0, aero_emission_att%ncat-1 )
-                ELSE
-                   message_string = 'Missing emission_mass_fracs in ' //  TRIM( input_file_salsa )
-                   CALL message( 'salsa_emission_setup', 'PA0659', 1, 2, 0, 6, 0 )
-                ENDIF
-!
-!--             If the chemical component is not activated, set its mass fraction to 0 to avoid
-!--             inbalance between number and mass flux
-                cc_i2m = aero_emission_att%cc_in2mod
-                IF ( index_so4 < 0  .AND.  cc_i2m(1) > 0 )                                         &
-                                                  aero_emission%def_mass_fracs(:,cc_i2m(1)) = 0.0_wp
-                IF ( index_oc  < 0  .AND.  cc_i2m(2) > 0 )                                         &
-                                                  aero_emission%def_mass_fracs(:,cc_i2m(2)) = 0.0_wp
-                IF ( index_bc  < 0  .AND.  cc_i2m(3) > 0 )                                         &
-                                                  aero_emission%def_mass_fracs(:,cc_i2m(3)) = 0.0_wp
-                IF ( index_du  < 0  .AND.  cc_i2m(4) > 0 )                                         &
-                                                  aero_emission%def_mass_fracs(:,cc_i2m(4)) = 0.0_wp
-                IF ( index_ss  < 0  .AND.  cc_i2m(5) > 0 )                                         &
-                                                  aero_emission%def_mass_fracs(:,cc_i2m(5)) = 0.0_wp
-                IF ( index_no  < 0  .AND.  cc_i2m(6) > 0 )                                         &
-                                                  aero_emission%def_mass_fracs(:,cc_i2m(6)) = 0.0_wp
-                IF ( index_nh  < 0  .AND.  cc_i2m(7) > 0 )                                         &
-                                                  aero_emission%def_mass_fracs(:,cc_i2m(7)) = 0.0_wp
-!
-!--             Then normalise the mass fraction so that SUM = 1
-                DO  in = 1, aero_emission_att%ncat
-                   aero_emission%def_mass_fracs(in,:) = aero_emission%def_mass_fracs(in,:) /       &
-                                                       SUM( aero_emission%def_mass_fracs(in,:) )
-                ENDDO
+                CALL get_date_time( time_since_reference_point, second_of_day=second_of_day )
+                next_aero_emission_update = MOD( second_of_day, seconds_per_hour ) !- seconds_per_hour
 !
 !--             Calculate average mass density (kg/m3)
@@ -8763,17 +8905,17 @@
 
                 IF ( cc_i2m(1) /= 0 )  aero_emission_att%rho = aero_emission_att%rho +  arhoh2so4 *&
-                                                           aero_emission%def_mass_fracs(:,cc_i2m(1))
+                                                               aero_emission%mass_fracs(:,cc_i2m(1))
                 IF ( cc_i2m(2) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhooc *    &
-                                                           aero_emission%def_mass_fracs(:,cc_i2m(2))
+                                                               aero_emission%mass_fracs(:,cc_i2m(2))
                 IF ( cc_i2m(3) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhobc *    &
-                                                           aero_emission%def_mass_fracs(:,cc_i2m(3))
+                                                               aero_emission%mass_fracs(:,cc_i2m(3))
                 IF ( cc_i2m(4) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhodu *    &
-                                                           aero_emission%def_mass_fracs(:,cc_i2m(4))
+                                                               aero_emission%mass_fracs(:,cc_i2m(4))
                 IF ( cc_i2m(5) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhoss *    &
-                                                           aero_emission%def_mass_fracs(:,cc_i2m(5))
+                                                               aero_emission%mass_fracs(:,cc_i2m(5))
                 IF ( cc_i2m(6) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhohno3 *  &
-                                                           aero_emission%def_mass_fracs(:,cc_i2m(6))
+                                                               aero_emission%mass_fracs(:,cc_i2m(6))
                 IF ( cc_i2m(7) /= 0 )  aero_emission_att%rho = aero_emission_att%rho + arhonh3 *   &
-                                                           aero_emission%def_mass_fracs(:,cc_i2m(7))
+                                                               aero_emission%mass_fracs(:,cc_i2m(7))
 !
 !--             Allocate and read surface emission data (in total PM)
@@ -8809,5 +8951,5 @@
                 ALLOCATE( aero_emission_att%dmid(1:nbins_aerosol),                                 &
                           aero_emission_att%time(1:aero_emission_att%nt),                          &
-                          aero_emission%preproc_mass_fracs(1:aero_emission_att%ncc) )
+                          aero_emission%num_fracs(1:aero_emission_att%ncat,1:nbins_aerosol) )
 !
 !--             Read mean diameters
@@ -8831,38 +8973,18 @@
                 ENDIF
 !
-!--             Read emission mass fractions
-                IF ( check_existence( aero_emission_att%var_names, 'emission_mass_fracs' ) )  THEN
-                   CALL get_variable( id_salsa, 'emission_mass_fracs',                             &
-                                      aero_emission%preproc_mass_fracs )
+!--             Read emission number fractions per category
+                IF ( check_existence( aero_emission_att%var_names, 'emission_number_fracs' ) )  THEN
+                   CALL get_variable( id_salsa, 'emission_number_fracs', aero_emission%num_fracs,  &
+                                      0, nbins_aerosol-1, 0, aero_emission_att%ncat-1 )
                 ELSE
-                   message_string = 'Missing emission_mass_fracs in ' //  TRIM( input_file_salsa )
+                   message_string = 'Missing emission_number_fracs in ' //  TRIM( input_file_salsa )
                    CALL message( 'salsa_emission_setup', 'PA0659', 1, 2, 0, 6, 0 )
                 ENDIF
-!
-!--             If the chemical component is not activated, set its mass fraction to 0
-                cc_i2m = aero_emission_att%cc_in2mod
-                IF ( index_so4 < 0  .AND.  cc_i2m(1) /= 0 )                                        &
-                   aero_emission%preproc_mass_fracs(cc_i2m(1)) = 0.0_wp
-                IF ( index_oc  < 0  .AND.  cc_i2m(2) /= 0 )                                        &
-                   aero_emission%preproc_mass_fracs(cc_i2m(2)) = 0.0_wp
-                IF ( index_bc  < 0  .AND.  cc_i2m(3) /= 0 )                                        &
-                   aero_emission%preproc_mass_fracs(cc_i2m(3)) = 0.0_wp
-                IF ( index_du  < 0  .AND.  cc_i2m(4) /= 0 )                                        &
-                   aero_emission%preproc_mass_fracs(cc_i2m(4)) = 0.0_wp
-                IF ( index_ss  < 0  .AND.  cc_i2m(5) /= 0 )                                        &
-                   aero_emission%preproc_mass_fracs(cc_i2m(5)) = 0.0_wp
-                IF ( index_no  < 0  .AND.  cc_i2m(6) /= 0 )                                        &
-                   aero_emission%preproc_mass_fracs(cc_i2m(6)) = 0.0_wp
-                IF ( index_nh  < 0  .AND.  cc_i2m(7) /= 0 )                                        &
-                   aero_emission%preproc_mass_fracs(cc_i2m(7)) = 0.0_wp
-!
-!--             Then normalise the mass fraction so that SUM = 1
-                aero_emission%preproc_mass_fracs = aero_emission%preproc_mass_fracs /              &
-                                                   SUM( aero_emission%preproc_mass_fracs )
 
              ELSE
                 message_string = 'Unknown lod for aerosol_emission_values.'
                 CALL message( 'salsa_emission','PA0637', 1, 2, 0, 6, 0 )
-             ENDIF
+
+             ENDIF  ! lod
 
           ENDIF  ! init
@@ -8877,8 +8999,8 @@
 !
 !--             Get the index of the current hour
-                CALL get_date_time( time_since_reference_point, &
+                CALL get_date_time( MAX( 0.0_wp, time_since_reference_point ),                     &
                                     day_of_year=day_of_year, hour=hour_of_day )
                 index_hh = ( day_of_year - 1_iwp ) * hours_per_day + hour_of_day
-                aero_emission_att%time_factor = aero_emission_att%etf(:,index_hh)
+                aero_emission_att%time_factor = aero_emission_att%etf(:,index_hh+1)
 
              ELSEIF ( aero_emission_att%nhoursyear < aero_emission_att%nmonthdayhour )  THEN
@@ -8886,9 +9008,6 @@
 !--             Get the index of current hour (index_hh) (TODO: Now "workday" is always assumed.
 !--             Needs to be calculated.)
-                CALL get_date_time( time_since_reference_point, &
-                                    month=month_of_year,        &
-                                    day=day_of_month,           &
-                                    hour=hour_of_day,           &
-                                    day_of_week=day_of_week     )
+                CALL get_date_time( MAX( 0.0_wp, time_since_reference_point ), month=month_of_year,&
+                                    day=day_of_month, hour=hour_of_day, day_of_week=day_of_week )
                 index_mm = month_of_year
                 index_dd = months_per_year + day_of_week
@@ -8907,5 +9026,5 @@
                 aero_emission_att%time_factor = aero_emission_att%etf(:,index_mm) *                &
                                                 aero_emission_att%etf(:,index_dd) *                &
-                                                aero_emission_att%etf(:,index_hh)
+                                                aero_emission_att%etf(:,index_hh+1)
              ENDIF
 
@@ -8939,10 +9058,10 @@
                 IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
                    CALL set_flux( surf_def_h(0), aero_emission_att%cc_in2mod,                      &
-                                  aero_emission%def_mass_fracs(in,:), source_array )
+                                  aero_emission%mass_fracs(in,:), source_array )
                 ELSE
                    CALL set_flux( surf_usm_h, aero_emission_att%cc_in2mod,                         &
-                                  aero_emission%def_mass_fracs(in,:), source_array )
+                                  aero_emission%mass_fracs(in,:), source_array )
                    CALL set_flux( surf_lsm_h, aero_emission_att%cc_in2mod,                         &
-                                  aero_emission%def_mass_fracs(in,:), source_array )
+                                  aero_emission%mass_fracs(in,:), source_array )
                 ENDIF
              ENDDO
@@ -8957,32 +9076,46 @@
           ELSEIF ( aero_emission_att%lod == 2 )  THEN
 !
-!--          Obtain time index for current input starting at 0.
-!--          @todo: At the moment emission data and simulated time correspond to each other.
-             aero_emission_att%tind = MINLOC( ABS( aero_emission_att%time -                        &
-                                                   time_since_reference_point ), DIM = 1 ) - 1
+!--          Get time_utc_init from origin_date_time
+             CALL get_date_time( 0.0_wp, second_of_day = time_utc_init )
+!
+!--          Obtain time index for current point in time. Note, the time coordinate in the input
+!--          file is relative to time_utc_init.
+             aero_emission_att%tind = MINLOC( ABS( aero_emission_att%time - (                      &
+                                                   time_utc_init + MAX( time_since_reference_point,&
+                                                                        0.0_wp) ) ), DIM = 1 ) - 1
 !
 !--          Allocate the data input array always before reading in the data and deallocate after
-             ALLOCATE( aero_emission%preproc_data(nys:nyn,nxl:nxr,1:nbins_aerosol) )
+             ALLOCATE( aero_emission%preproc_data(nys:nyn,nxl:nxr,1:aero_emission_att%ncat),       &
+                       source_array(nys:nyn,nxl:nxr,1:nbins_aerosol) )
 !
 !--          Read in the next time step
-             CALL get_variable( id_salsa, 'aerosol_emission_values', aero_emission%preproc_data,&
-                                aero_emission_att%tind, 0, nbins_aerosol-1, nxl, nxr, nys, nyn )
-!
-!--          Set surface fluxes of aerosol number and mass on horizontal surfaces. Set fluxes only
-!--          for either default, land and urban surface.
-             IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
-                CALL set_flux( surf_def_h(0), aero_emission_att%cc_in2mod,                         &
-                               aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
-             ELSE
-                CALL set_flux( surf_usm_h, aero_emission_att%cc_in2mod,                            &
-                               aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
-                CALL set_flux( surf_lsm_h, aero_emission_att%cc_in2mod,                            &
-                               aero_emission%preproc_mass_fracs, aero_emission%preproc_data )
-             ENDIF
+             CALL get_variable( id_salsa, 'aerosol_emission_values', aero_emission%preproc_data,   &
+                                aero_emission_att%tind, 0, aero_emission_att%ncat-1,               &
+                                nxl, nxr, nys, nyn )
+!
+!--          Calculate the sources per category and set surface fluxes
+             source_array = 0.0_wp
+             DO  in = 1, aero_emission_att%ncat
+                DO  ib = 1, nbins_aerosol
+                   source_array(:,:,ib) = aero_emission%preproc_data(:,:,in) *                     &
+                                          aero_emission%num_fracs(in,ib)
+                ENDDO
+!
+!--             Set fluxes only for either default, land and urban surface.
+                IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
+                   CALL set_flux( surf_def_h(0), aero_emission_att%cc_in2mod,                      &
+                                  aero_emission%mass_fracs(in,:), source_array )
+                ELSE
+                   CALL set_flux( surf_usm_h, aero_emission_att%cc_in2mod,                         &
+                                  aero_emission%mass_fracs(in,:), source_array )
+                   CALL set_flux( surf_lsm_h, aero_emission_att%cc_in2mod,                         &
+                                  aero_emission%mass_fracs(in,:), source_array )
+                ENDIF
+             ENDDO
 !
 !--          Determine the next emission update
              next_aero_emission_update = aero_emission_att%time(aero_emission_att%tind+2)
 
-             DEALLOCATE( aero_emission%preproc_data )
+             DEALLOCATE( aero_emission%preproc_data, source_array )
 
           ENDIF
@@ -9347,5 +9480,5 @@
 !--       Next emission update
           CALL get_date_time( time_since_reference_point, second_of_day=second_of_day )
-          next_gas_emission_update = MOD( second_of_day, seconds_per_hour ) - seconds_per_hour
+          next_gas_emission_update = MOD( second_of_day, seconds_per_hour ) !- seconds_per_hour
 !
 !--       Allocate and read surface emission data (in total PM) (NOTE that "preprocessed" input data
@@ -9395,5 +9528,7 @@
                               day_of_year=day_of_year, hour=hour_of_day )
           index_hh = ( day_of_year - 1_iwp ) * hours_per_day + hour_of_day
-          time_factor = chem_emission_att%hourly_emis_time_factor(:,index_hh)
+          IF ( .NOT. ALLOCATED( time_factor ) )  ALLOCATE( time_factor(1:chem_emission_att%ncat) )
+          time_factor = 0.0_wp
+          time_factor = chem_emission_att%hourly_emis_time_factor(:,index_hh+1)
 
        ELSEIF ( chem_emission_att%nhoursyear < chem_emission_att%nmonthdayhour )  THEN
@@ -9408,5 +9543,5 @@
           index_mm = month_of_year
           index_dd = months_per_year + day_of_week
-          SELECT CASE(TRIM(daytype))
+          SELECT CASE( TRIM( daytype ) )
 
              CASE ("workday")
@@ -9422,5 +9557,5 @@
           time_factor = chem_emission_att%mdh_emis_time_factor(:,index_mm) *                       &
                         chem_emission_att%mdh_emis_time_factor(:,index_dd) *                       &
-                        chem_emission_att%mdh_emis_time_factor(:,index_hh)
+                        chem_emission_att%mdh_emis_time_factor(:,index_hh+1)
        ENDIF
 !
@@ -9435,11 +9570,11 @@
 !--       Set surface fluxes only for either default, land or urban surface
           IF ( .NOT. land_surface  .AND.  .NOT. urban_surface )  THEN
-             CALL set_gas_flux( surf_def_h(0), emission_index_chem, chem_emission_att%units,       &
-                                dum_var_3d(:,:,in), time_factor(in) )
+             CALL set_gas_flux( surf_def_h(0), emission_index_chem, chem_emission_att%units,    &
+                                dum_var_3d, time_factor(in) )
           ELSE
-             CALL set_gas_flux( surf_usm_h, emission_index_chem, chem_emission_att%units,          &
-                                dum_var_3d(:,:,in), time_factor(in) )
-             CALL set_gas_flux( surf_lsm_h, emission_index_chem, chem_emission_att%units,          &
-                                dum_var_3d(:,:,in), time_factor(in) )
+             CALL set_gas_flux( surf_usm_h, emission_index_chem, chem_emission_att%units,       &
+                                dum_var_3d, time_factor(in) )
+             CALL set_gas_flux( surf_lsm_h, emission_index_chem, chem_emission_att%units,       &
+                                dum_var_3d, time_factor(in) )
           ENDIF
        ENDDO
@@ -9451,8 +9586,11 @@
     ELSEIF ( lod_gas_emissions == 2 )  THEN
 !
-!--    Obtain time index for current input starting at 0.
-!--    @todo: At the moment emission data and simulated time correspond to each other.
-       chem_emission_att%i_hour = MINLOC( ABS( gas_emission_time - time_since_reference_point ),   &
-                                          DIM = 1 ) - 1
+!--    Get time_utc_init from origin_date_time
+       CALL get_date_time( 0.0_wp, second_of_day = time_utc_init )
+!
+!--    Obtain time index for current point in time. Note, the time coordinate in the input file is
+!--    relative to time_utc_init.
+       chem_emission_att%i_hour = MINLOC( ABS( gas_emission_time - ( time_utc_init +               &
+                                         MAX( time_since_reference_point, 0.0_wp) ) ), DIM = 1 ) - 1
 !
 !--    Allocate the data input array always before reading in the data and deallocate after (NOTE 
@@ -9527,5 +9665,5 @@
        REAL(wp), DIMENSION(ngases_salsa) ::  conv     !< unit conversion factor
 
-       REAL(wp), DIMENSION(nys:nyn,nxl:nxr,chem_emission_att%n_emiss_species), INTENT(in) ::  source_array  !<
+       REAL(wp), DIMENSION(nys:nyn,nxl:nxr,1:chem_emission_att%n_emiss_species), INTENT(in) ::  source_array  !<
 
        TYPE(surf_type), INTENT(inout) :: surface  !< respective surface type
